// TFC_arnauduran.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <fstream>
#include <stdio.h>      /* printf, scanf, puts, NULL */
#include <stdlib.h>     /* srand, rand */
#include <time.h>       /* time */
#include <algorithm>    // std::random_shuffle
#include <vector>
using namespace std;


//////////////DEFINICIONS//////////////

#define EXECUCIONS_GILLESPIE 10

/////////////////TIPUS/////////////////

typedef struct{
	long node;
	double prob;
	int canvi;
} info_t_reaccions;

////////////////ACCIONS////////////////

bool aresta_existent(long node1, long node2, vector< vector<long> > &t_xarxa){
	//////Descripci//////
	// Retorna true si existeix l'aresta entre node1 i node2, o false si no existeix
	///////Variables//////
	long i;
	bool vei;
	///Inicialitzacions///
	i = 0;
	vei = false;
	//////Sentncies//////
	if (node1 > t_xarxa.size() || node2 > t_xarxa.size()){//per si de cas...
		vei = false;
	}
	else{
		for (i = 0; i < t_xarxa.at(node1).size(); i++){
			//recorrem tots els vens del node1 i mirem si hi ha node2
			if (t_xarxa.at(node1).at(i) == node2){
				vei = true;
			}
		}
	}
	return vei;
}

void inicialitza(float &beta, float &mu, float &temps_final, float &mostratge, int &nodes, float &infectats, int &tipus){
	//////Descripci//////
	// Demana valor per la beta (possibilitat d'infecci), la mu (possibilitat de recuperaci),
	// el nombre de nodes, el nombre de nodes infectats d'inici i el tipus de xarxa desitjada.
	///////Variables//////
	int i;
	///Inicialitzacions///
	i = 0;
	//////Sentncies//////

	cout << "Entra el valor de la beta (possibilitat dinfeccio): ";
	cin >> beta;
		while ( beta > 1 || beta < 0 ){
		cout << "La beta ha d'estar entre 0 i 1. Entra-la de nou: ";
		cin >> beta;
	}
	cout << "Entra el valor de la mu (possibilitat de recuperacio): ";
	cin >> mu;
	while (mu > 1 || mu < 0){
		cout << "La mu ha d'estar entre 0 i 1. Entra-la de nou: ";
		cin >> mu;
	}

	cout << "Quina probabilitat tenen els nodes d'estar infectats d'inici (entre 0 i 1)?";
	cin >> infectats;
	cout << "Entra el nombre de nodes de la xarxa: ";
	cin >> nodes;
	cout << "Quin tipus de xarxa vols? (1=reticula, 2=complet, 3=power-law, 4=regular, 5=Erdos-Renyi): ";
	cin >> tipus;

	/*
	beta = 0.3;
	mu = 0.7;
	infectats = 0.5;
	*/

	mostratge = 0.1;
	temps_final = 50;
}

void genera_xarxa_reticula(int tipus, int nodes, vector< vector<long> > &t_xarxa){
	//////Descripci//////
	// Genera una xarxa del tipus retcula. Nota: no ordena les arestes de cada node.
	///////Variables//////
	int i;
	int j;
	int width;
	int height;
	int comptador_alfa;
	int comptador_beta;
	vector<long> t_arestes;
	///Inicialitzacions///
	i = 0;
	j = 0;
	comptador_alfa = 0;
	comptador_beta = 0;
	//////Sentncies//////
	cout << "Entra l'amplada de la reticula: ";
	cin >> width;
	while (width < 0){
		cout << "L'amplada ha de ser major que 0. Entra-la de nou: ";
		cin >> width;
	}
	cout << "Entra l'alssada de la reticula: ";
	cin >> height;
	while (height < 0){
		cout << "L'alssada ha de ser major que 0. Entra-la de nou: ";
		cin >> height;
	}
	if (width * height != nodes){
		cout << endl << "width*height no es igual al nombre de nodes!! Ja t'hi val! tanca el programa i torna a engegar-lo";
		cin >> i;
	}
	for (i = 0; i < width; i++){
		for (j = 0; j < height; j++){
			//estem al node (i,j)
			t_arestes.clear();
			//lligar amunt
			if (j != 0){
				t_arestes.push_back(comptador_alfa - 1);
			}
			//lligar avall
			if (j != (height - 1)){
				t_arestes.push_back(comptador_alfa + 1);
			}
			//lligar esquerra
			if (i != 0){
				t_arestes.push_back(comptador_alfa - height);
			}
			//lligar dreta
			if (i != (width - 1)){
				t_arestes.push_back(comptador_alfa + height);
			}
			comptador_alfa++;
			t_xarxa.push_back(t_arestes);
		}
	}
}

void genera_xarxa_completa(int tipus, int nodes, vector< vector<long> > &t_xarxa){
	//////Descripci//////
	// Genera una xarxa del tipus complet (tots amb tots)
	///////Variables//////
	int i;
	int j; 
	vector<long> t_arestes;
	///Inicialitzacions///
	i = 0;
	j = 0;
	//////Sentncies//////

	for (i = 0; i < nodes; i++){
		t_arestes.clear();
		for (j = 0; j < nodes; j++){
			//passem per tots els nodes excepte ell mateix
			if (i != j){
				t_arestes.push_back(j);
			}
		}
		t_xarxa.push_back(t_arestes);
	}
}

void genera_xarxa_regular(int tipus, int nodes, vector< vector<long> > &t_xarxa){
	//////Descripci//////
	// Genera una xarxa del tipus regular (tots els nodes de grau k) mitjanant configuration model
	///////Variables//////
	long i;
	long j;
	long it;
	long grau;
	vector<int> v;
	vector<long> arestes_provisional;
	///Inicialitzacions///
	i = 0;
	j = 0;
	it = 0;
	grau = 0;
	//////Sentncies//////
	while (grau <= 0){
		cout << "Entra el grau dels nodes (grau > 0)";
		cin >> grau;
	}
	//ja tenim els graus de tots els nodes. construim v
	for (i = 0; i < nodes; i++){
		for (j = 0; j < grau; j++){
			v.push_back(i);
		}
	}
	//fem permutaci a l'atzar
	random_shuffle(v.begin(), v.end());

	// construm una xarxa de nodes sense arestes
	for (i = 0; i < nodes; i++){
		arestes_provisional.clear();
		t_xarxa.push_back(arestes_provisional);
	}
	//noms queda construir les parelles.
	for (it = 0; it < v.size(); it = it + 2){ //fem passos dobles (parelles)		
		//agafem la parella
		i = v.at(it);
		j = v.at(it + 1);
		//si sn iguals o l'aresta ja existeix, no fem res.
		if (i != j && aresta_existent(i, j, t_xarxa) == false){
			//inserta aresta a la xarxa
			t_xarxa.at(i).push_back(j);
			t_xarxa.at(j).push_back(i);
		}
	}
	//ja no ens serveix
	v.clear();
}

void genera_xarxa_powerlaw(int tipus, int nodes, vector< vector<long> > &t_xarxa){
	//////Descripci//////
	// Genera una xarxa del tipus power-law. P(k)=k*(-gamma). Mitjanant configuration model.
	///////Variables//////
	long i;
	long j;
	long it;
	double gamma;
	double cutoff; //cutoff inferior
	double y;
	double k_i;
	long compt_k;
	vector<int> k;
	vector<int> v;
	vector<long> arestes_provisional;
	///Inicialitzacions///
	i = 0;
	j = 0;
	it = 0;
	gamma = 0;
	cutoff = 0;
	k_i = 0;
	compt_k = 0;
	//////Sentncies//////
	while (cutoff <= 0){
		cout << "Entra el grau minim dels nodes (grau minim > 0)";
		cin >> cutoff;
	}
	while (gamma <= 2){
		cout << "Entra la gamma (gamma > 2)";
		cin >> gamma;
	}
	for (i = 0; i < nodes; i++){
		// trobem K[i]
		y = ((double)rand() / (RAND_MAX));//nombre aleatori >0
		while (y == 0){
			y = ((double)rand() / (RAND_MAX));
		}
		k_i = cutoff*pow(1 - ((((double)nodes - 1) * y)/ (double)nodes),1 / (1 - gamma)); //frmula
		k_i = (int)ceil(k_i); //arrodoniment superior
		k.push_back(k_i);
	}
	for (j = 0; j < k.size(); j++){
		compt_k = compt_k + k.at(j);
	}
	//compt_k ha de ser parell; si no ho s, modifiquem un node a l'atzar (li sumem 1)
	if (compt_k % 2 != 0){
		y = (int)ceil(nodes*((double)rand() / (RAND_MAX)));//nombre aleatori [0,nodes]
		k.at(y) = k.at(y) + 1;
	}
	//ja tenim els graus de tots els nodes. construim v
	for (i = 0; i < nodes; i++){
		for (j = 0; j < k.at(i); j++){
			v.push_back(i);
		}
	}
	//fem permutaci a l'atzar
	random_shuffle(v.begin(), v.end());

	// construm una xarxa de nodes sense arestes
	for (i = 0; i < nodes; i++){
		arestes_provisional.clear();
		t_xarxa.push_back(arestes_provisional);
	}
	//noms queda construir les parelles.
	for (it = 0; it < v.size(); it=it+2){ //fem passos dobles (parelles)		
		//agafem la parella
		i = v.at(it);
		j = v.at(it+1);
		//si sn iguals o l'aresta ja existeix, no fem res.
		if (i != j && aresta_existent(i,j,t_xarxa)==false){
			//inserta aresta a la xarxa
			t_xarxa.at(i).push_back(j);
			t_xarxa.at(j).push_back(i);
		}
	}
	//ja no ens serveixen
	v.clear();
	k.clear();
}

void genera_xarxa_erdosrenyi(int tipus, int nodes, vector< vector<long> > &t_xarxa){
	//////Descripci//////
	// Genera una xarxa del tipus complet (tots amb tots)
	///////Variables//////
	int i;
	int j;
	float y;
	float prob;
	vector<long> t_arestes;
	///Inicialitzacions///
	i = 0;
	j = 0;
	prob = 0;
	//////Sentncies//////
	while (prob <= 0 || prob > 1){
		std::cout << "Entra la probabilitat d'aresta ([0,1])";
		std::cin >> prob;
	}


	// construm una xarxa de nodes sense arestes
	for (i = 0; i < nodes; i++){
		t_arestes.clear();
		t_xarxa.push_back(t_arestes);
	}
	for (i = 0; i < nodes-1; i++){//mirem fins al penltim, que avaluar la parella amb l'ltim. No t sentit mirar l'ltim
		for (j = i+1; j < nodes; j++){//mirem a partir del segent, no volem mirar la mateixa aresta dos cops.
			y = ((double)rand() / (RAND_MAX));//nombre aleatori [0,1]
			if (y < prob){
				t_xarxa.at(i).push_back(j);
				t_xarxa.at(j).push_back(i);
			}
		}
	}
}

void genera_xarxa(int tipus, int nodes, vector< vector<long> > &t_xarxa){
	//////Descripci//////
	// Genera una xarxa del tipus desitjat, amb tants nodes com s'hagin demanat
	// i amb tants nodes infectats com s'hagin demanat.
	// 1 = retcula; 2 = complet; 3= power-law
	///////Variables//////
	int continuar;
	///Inicialitzacions///
	continuar = 0;
	//////Sentncies//////
	switch (tipus){
	case 1: genera_xarxa_reticula(tipus, nodes, t_xarxa);
		break;
	case 2: genera_xarxa_completa(tipus, nodes, t_xarxa);
		break;
	case 3: genera_xarxa_powerlaw(tipus, nodes, t_xarxa);
		break;
	case 4: genera_xarxa_regular(tipus, nodes, t_xarxa);
		break;
	case 5: genera_xarxa_erdosrenyi(tipus, nodes, t_xarxa);
		break;
	default: genera_xarxa_completa(tipus, nodes, t_xarxa);
	}
	//comprovem si hi ha algun node suelto;
	/*
	for (i = 0; i < t_xarxa.size(); i++){
		if (t_xarxa.at(i).size() == 0){
			cout << endl << "El node " << i << " no t cap aresta! qu hem de fer? Aturo el programa.";
			cin >> continuar;
		}
	}
	*/
}

void infecta(float &infectats, vector< vector<long> > t_xarxa, vector<int> &t_infectats){
	//////Descripci//////
	// Conegut el nombre de nodes de la xarxa, infecta els nodes segons el nombre d'infectats determinat per l'usuari anteriorment
	///////Variables//////
	int i, j;
	long nombre_infectats;
	int random;
	long mida;
	///Inicialitzacions///
	i = 0;
	j = 0;
	random = 0;
	mida = t_xarxa.size();
	nombre_infectats = ceil(infectats * mida);
	//////Sentncies//////
	for (i = 0; i < mida; i++){
		t_infectats.push_back(0);
	}
	for (i = 0; i < nombre_infectats; i++){
		random = ceil(rand() % mida);
		for (j = random;; j++){
			if (t_infectats.at(j) == 0){
				t_infectats.at(j) = 1;
				break;
			}
			if (j == mida - 1){
				j = 1;
			}
		}
	}
}

void imprimeix_xarxa(vector< vector<long> > t_xarxa, vector<int> t_infectats){
	//////Descripci//////
	// Imprimeix la xarxa mostrant si els nodes estan infectats o no. Serveix a efectes de testing.
	///////Variables//////
	int i;
	int j;
	long mida;
	///Inicialitzacions///
	i = 0;
	j = 0;
	//////Sentncies//////
	mida = t_xarxa.size();
	for (i = 0; i<mida; i++){
		cout << "Vertex " << i << " (";
		if (t_infectats.at(i) == 1){
			cout << "infectat";
		}
		else{
			cout << "sa";
		}
		cout << "), connecta amb ";
		for (j = 0; j < t_xarxa.at(i).size(); j++){
			try {
				cout << t_xarxa.at(i).at(j) << ",";
			}
			catch (exception& e) {
				cout << "Element " << j << ": index exceeds vector dimensions." << endl;
			}
		}
		cout << endl;
	}
}

void gillespie_complet(int nodes, float infectats, vector< vector<long> > t_xarxa, vector<long> &t_valors_indiv, float beta, float mu, float temps_final, float mostratge, int exec_gillespie){
	//////Descripci//////
	// Aplica mltiples iteracions de l'algorisme de Gillespie fins que s'assoleix el temps mxim determinat per l'usuari
	///////Variables//////
	float temps;
	bool acabat;
	long comptador;
	long comptador_escriure;
	clock_t t1, t2;
	float seconds;
	int nombre_infectats;
	float percentatge_infectats;
	vector<int> t_infectats;
	FILE * arxiu;
	long i;
	long k;
	long m;
	double n;
	double r1;
	double r2;
	double a0;
	double r2a0;
	double tau;
	long j;
	long nombre_de_reaccions;
	long mida;
	long mida2;
	vector<info_t_reaccions> t_reaccions;
	///Inicialitzacions///
	acabat = false;
	nombre_infectats = 0;
	temps = 0;
	comptador = 0;
	comptador_escriure = 1;
	i = 0;
	j = 0;
	m = 0;
	n = 0;
	mida = 0;
	mida2 = 0;
	//////Sentncies//////
	// infectem (diferent per cada execuci)
	infecta(infectats, t_xarxa, t_infectats);

	//escrivim nombre d'infectats en t=0
	mida = t_infectats.size();
	for (i = 0; i < mida; i++){
		if (t_infectats.at(i) == 1){
			nombre_infectats++;
		}
	}
	t_valors_indiv.push_back(nombre_infectats);

	t1 = clock();
	while (acabat == false){
		//anem repetint fins que detecti que s'acaba
		a0 = 0;
		r2a0 = 0;
		nombre_de_reaccions = 0;
		k = 0;

		///// INICI ITERACI GILLESPIE ////
		//gillespie(t_xarxa, t_infectats_provisional, beta, mu, temps, temps_final, acabat);
		//generem dos nombres aleatoris r1 i r2 en l'interval [0,1] amb distribuci uniforme. >0
		r1 = ((double)rand() / (RAND_MAX));
		r2 = ((double)rand() / (RAND_MAX));
		while ((r1 == 0) || (r2 == 0)){
			r1 = ((double)rand() / (RAND_MAX));
			r2 = ((double)rand() / (RAND_MAX));
		}
		//trobem tots els aj
		//hem de mirar, per cada node, totes les seves arestes, i segons el node amb el qual estigui connectat tindr una probabilitat beta o mu.
		mida = t_xarxa.size();
		for (i = 0; i < mida; i++){
			if (t_infectats.at(i) == 1){
				//el node est infectat. t probabilitat mu de recuperar-se
				t_reaccions.push_back({ i, mu, -1 });
				a0 = a0 + mu;
				k++;
			}
			else{
				//el node est sa. mirem quants vens infectats t. cadascun d'ells li dna probabilitat beta d'infectar-se.
				mida2 = t_xarxa.at(i).size();
				for (m = 0; m < mida2; m++){
					//estem mirant els vens de i, que ara tenen l'ndex m.
					if (t_infectats.at(t_xarxa.at(i).at(m)) == 1){
						t_reaccions.push_back({ i, beta, +1 });
						a0 = a0 + beta;
						k++;
					}
				}
			}

		}
		nombre_de_reaccions = k - 1;
		// ep! a0 no pot ser 0. Quan aix passa vol dir q tots els nodes ja estan sans.
		if (a0 == 0){
			//tots sans
			temps = temps_final; //acabem
			acabat = true;
		}
		else{
			//trobem tau (temps que passa)
			tau = (1 / a0) * log(1 / r1);
			if (temps + tau <= temps_final){
				//trobem j (reacci que t lloc)
				r2a0 = r2*a0;
				n = t_reaccions.at(0).prob;//ja s'inicia amb el primer
				k = 0;
				while (n <= r2a0){
					n = n + t_reaccions.at(k).prob;
					k++;
				}
				j = k - 1;
				if (j < 1){
					j = 0;
				}//per si salta el primer directe
				//cout << endl << "toca la reaccio que afecta el node " << t_reaccions.at(j).node << " que tenia probabilitat " << t_reaccions.at(j).prob;
				//cout << " de patir un canvi " << t_reaccions.at(j).canvi;
				//actualitzem temps
				temps = temps + tau;
				//actualitzem estat (taula d'infectats)
				t_infectats.at(t_reaccions.at(j).node) = t_infectats.at(t_reaccions.at(j).node) + t_reaccions.at(j).canvi;
			}
			else{
				acabat = true;
			}
		}
		t_reaccions.clear(); // esborrar contingut per la propera iteraci


		///// FINAL ITERACI GILLESPIE ////

		//mirem si toca fer mostratge
		if (temps >= comptador_escriure * mostratge){
			//mirem aviam si hem saltat ms d'un mostratge (ex. de 0.1 a 0.4) i actuem en conseqncia (escrivim nombre_infectats del darrer mostratge tractat)
			//excepte si acabat=true, llavors cal escriure el nou mostratge.
			if (acabat == false){
				while (temps >= (comptador_escriure + 1)*mostratge){
					t_valors_indiv.push_back(nombre_infectats);
					comptador_escriure++;
				}
			}
			else{
				nombre_infectats = 0;
				mida = t_infectats.size();
				for (i = 0; i < mida; i++){
					if (t_infectats.at(i) == 1){
						nombre_infectats++;
					}
				}
				while (temps >= (comptador_escriure + 1)*mostratge){
					t_valors_indiv.push_back(nombre_infectats);
					comptador_escriure++;
				}
			}
			nombre_infectats = 0;
			//comptem infectats
			mida = t_infectats.size();
			for (i = 0; i < mida; i++){
				if (t_infectats.at(i) == 1){
					nombre_infectats++;
				}
			}
			t_valors_indiv.push_back(nombre_infectats);
			comptador_escriure++;
		}
		comptador++;
	}
	//escrivim el darrer instant si s necessari (s necessari sempre excepte que el temps final sigui exactament el temps actual), altrament dit,
	//que s'hagi fet per exemple 1000 mostres (temps_final=100, mostratge=10) i que falti la 1001 (pel t=100 exacte). Pot ser que falti ms d'un instant
	// (p.ex. si hem passat de 99.71 a 100
	nombre_infectats = 0;
	mida = t_infectats.size();
	for (i = 0; i < mida; i++){
		if (t_infectats.at(i) == 1){
			nombre_infectats++;
		}
	}
	while (t_valors_indiv.size() != (temps_final / mostratge +1)){
		t_valors_indiv.push_back(nombre_infectats);
	}
	////
	t2 = clock();
	float diff((float)t2 - (float)t1);
	seconds = diff / CLOCKS_PER_SEC;
	cout << "S'ha executat el Gillespie numero " << exec_gillespie << ". Ha tardat " << seconds << " segons (" << comptador-1 << " iteracions, temps=" << temps <<"). ";
	percentatge_infectats = (float)nombre_infectats / (float)nodes * 100;
	cout << "Nombre d'infectats: " << nombre_infectats << " de " << nodes << " (" << percentatge_infectats << "%)" << endl;
	t_infectats.clear(); // esborrar contingut per la propera iteraci
}

void gillespie_multiple(int nodes, float infectats, vector< vector<long> > t_xarxa, float beta, float mu, float temps_final, float mostratge){
	//////Descripci//////
	// Executa l'algorisme de Gillespie diversos cops (EXECUCIONS_GILLESPIE)
	///////
	///////Variables//////
	long i;
	long j;
	float mitjana;
	vector<long> t_valors_indiv;
	vector< vector<long> > t_valors;
	vector<float> t_mitjanes;
	FILE * arxiu;
	///Inicialitzacions///
	i = 0;
	//////Sentncies//////
	for (i = 0; i < EXECUCIONS_GILLESPIE; i++){
		t_valors_indiv.clear();
		gillespie_complet(nodes, infectats, t_xarxa,  t_valors_indiv, beta, mu, temps_final, mostratge, i);
		t_valors.push_back(t_valors_indiv); //afegim columna
		if (t_valors_indiv.size() != (temps_final / mostratge + 1)){
			cout << "ERROR!! t_valors_indiv ha de donar mostratge/temps_final+1. Arnau revisa el codi! t_valors_indiv.size()=" << t_valors_indiv.size() << endl;
			cin >> mitjana;
		}
	}
	arxiu = fopen("dades.m", "w");
	fprintf(arxiu, "%% DADES INFECTATS GILLESPIE MULTIPLE %%\n\nx=0:%f:%f;\ninfectats = [", mostratge, temps_final);
	for (i = 0; i < (temps_final / mostratge + 1); i++){
		//calculem mitjana
		mitjana = 0;
		for (j = 0; j < t_valors.size(); j++){
			mitjana = mitjana + t_valors.at(j).at(i);
		}
		mitjana = mitjana / (t_valors.size());
		fprintf(arxiu, "%f ", mitjana);
	}
	fprintf(arxiu, "];\n\nplot(x, infectats)\naxis([0,%f,0,%d])\nxlabel('temps');\nylabel('infectats');\ntitle('Nombre dinfectats al llarg del temps');", temps_final, nodes);
	fclose(arxiu);
	cout << endl << "S'ha escrit l'arxiu de dades." << endl;
}

void main(){
	//////Descripci//////
	// Funci principal
	///////Variables//////
	float beta;
	float mu;
	float temps_final;
	float mostratge;
	int nodes;
	float infectats;
	int tipus;
	int acabar;

	vector< vector<long> > t_xarxa;


	///Inicialitzacions///
	srand(time(NULL)); // llavor aleatria
	//////Sentncies//////

	inicialitza(beta, mu, temps_final, mostratge, nodes, infectats, tipus);
	genera_xarxa(tipus, nodes, t_xarxa);
	//imprimeix_xarxa( t_xarxa, t_infectats);
	//cin >> acabar; // espera un moment
	gillespie_multiple(nodes, infectats, t_xarxa, beta, mu, temps_final, mostratge);
	//imprimeix_xarxa(t_alfa, t_beta, t_infectats);
	
	cin >> acabar; // perqu no tanqui la consola
}